#include <qthing.h>

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"

#include "driver/gpio.h"

#include "mqtt_common.h"
#include "esp_log.h"


#include "IRSender.hpp"

#include "Arduino.h"


// #######################
// ####### CONFIG ########
// #######################

const uint8_t senderTX = 26;
const uint8_t senderCLK = 25;

const uint8_t receiverRX = 23;

// ### end cfg ###


HardwareSerial sender(1);
HardwareSerial receiver(2);


void senderTask(void *ignored) {

  uint16_t delay = 10;
  vTaskDelay(delay / portTICK_PERIOD_MS);

  while (true) {
    sender.print("Hello, Infrared communication!");
    vTaskDelay(delay / portTICK_PERIOD_MS);

    sender.print(" typing…");
    vTaskDelay(delay / portTICK_PERIOD_MS);

    sender.print(" 🐾…");
    vTaskDelay(delay / portTICK_PERIOD_MS);

    sender.println(" 🕷🕸😏");
    vTaskDelay(delay / portTICK_PERIOD_MS);
  }
}


void receiverTask(void *ignored) {
  while (true) {
    if (receiver.available())
      Serial.print( (char)receiver.read() );
    else
      vTaskDelay(2);
  }
}


void device_main() {

  // ground the pin beneath our channel 0 IO
  uint8_t GND = 23;

  gpio_config_t conf;

  conf.intr_type = GPIO_INTR_DISABLE;
  conf.mode = GPIO_MODE_OUTPUT;
  conf.pin_bit_mask = 1ULL << GND;
  conf.pull_up_en = GPIO_PULLUP_DISABLE;
  conf.pull_down_en = GPIO_PULLDOWN_DISABLE;

  gpio_config(&conf);
  gpio_set_level((gpio_num_t)GND, 0);




  // IRSender(senderTX, senderCLK);
  // TODO: configure UART in IRSender!


  // sender.begin(baud, SERIAL_8N1, -1, senderTX);  // tx = 27
  // receiver.begin(baud, SERIAL_8N1, receiverRX, -1);  // rx = 26

  // xTaskCreate(senderTask, "sender", 8192, NULL, 6, NULL);
  // xTaskCreate(receiverTask, "receiver", 8192, NULL, 6, NULL);


  enable_wlan();
}
